/******************************************************************************
    Program ictdatedit, builds and edit database from analyze test files,
    for ic-tester program:
    - dialog.c - source file for function which creates dialog popups

    Copyright (C) 2001 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#include <gtk/gtk.h>

#include "ictdat.h"
#include "refresh.h"
#include "dialog.h"

void quick_message(gchar *message) {
GtkWidget *Dialog, *Label, *Button;

Dialog = gtk_dialog_new();
Label = gtk_label_new (message);
Button = gtk_button_new_with_label("Ah, OK!");

gtk_signal_connect_object (GTK_OBJECT (Button), "clicked",
		GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (Dialog));
gtk_container_add (GTK_CONTAINER (GTK_DIALOG(Dialog)->action_area),Button);
gtk_container_add (GTK_CONTAINER (GTK_DIALOG(Dialog)->vbox),Label);
gtk_widget_set_usize (Label, -2, 100);
gtk_window_set_position (GTK_WINDOW (Dialog), GTK_WIN_POS_CENTER);
gtk_widget_show_all (Dialog);
}/* end quick_message() */

void on_rezultat_clicked (GtkButton *button, gpointer user_data)
{ if((GPOINTER_TO_INT(user_data)!=-1)&&(GPOINTER_TO_INT(user_data)<2))
 rezultat=GPOINTER_TO_INT(user_data);dialog_active=FALSE;}/* end of function */

void file_ok_sel (GtkWidget *w, GtkFileSelection *fs)
{
strcpy(fileloc, gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
dialog_active=FALSE;/* end wait loop */
}/* file_ok_sel() */ 

void create_savelog (gchar *title, gchar *defloc, gchar *filter)
{
  GtkWidget *Savelog;
  GtkWidget *ok_button1;
  GtkWidget *cancel_button1;

  dialog_active=TRUE;fileloc[0]=0;
  Savelog = gtk_file_selection_new (title);
  gtk_object_set_data (GTK_OBJECT (Savelog), "Savelog", Savelog);
  gtk_container_set_border_width (GTK_CONTAINER (Savelog), 2);

  ok_button1 = GTK_FILE_SELECTION (Savelog)->ok_button;
  gtk_object_set_data (GTK_OBJECT (Savelog), "ok_button1", ok_button1);
  gtk_widget_show (ok_button1);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);

  cancel_button1 = GTK_FILE_SELECTION (Savelog)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (Savelog), "cancel_button1", cancel_button1);
  gtk_widget_show (cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);
  gtk_file_selection_complete (GTK_FILE_SELECTION (Savelog), filter);
  gtk_file_selection_set_filename (GTK_FILE_SELECTION (Savelog), defloc);

  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (Savelog)->ok_button), "clicked", (GtkSignalFunc) file_ok_sel, Savelog );
  gtk_signal_connect_object (
		GTK_OBJECT (GTK_FILE_SELECTION (Savelog)->cancel_button),
                      "clicked", GTK_SIGNAL_FUNC (on_rezultat_clicked),
		      GINT_TO_POINTER(-1));
  gtk_signal_connect (GTK_OBJECT (Savelog), "destroy",
                      GTK_SIGNAL_FUNC (on_rezultat_clicked),
		      GINT_TO_POINTER(-1));
  gtk_signal_connect (GTK_OBJECT (Savelog), "delete_event",
		(GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (Savelog));
  gtk_widget_show (Savelog);while(dialog_active) g_refresh();/* until closed */
  gtk_widget_destroy(Savelog);
}/* end create_savelog() */

void qdialog(const gchar *message)
{
  GtkWidget *dialog1;
  GtkWidget *table2;
  GtkWidget *button2;
  GtkWidget *button1;
  GtkWidget *label1;

  dialog1 = gtk_window_new (GTK_WINDOW_DIALOG);
  label1 = gtk_label_new (message);
  button1 = gtk_button_new_with_label("Yeah, go for it!");
  button2 = gtk_button_new_with_label("Nooooooooo !!!!!");
  table2 = gtk_table_new (2, 2, FALSE);

  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
  gtk_window_set_title (GTK_WINDOW (dialog1), ("Hm, and what to do now?"));
  gtk_window_set_position (GTK_WINDOW (dialog1), GTK_WIN_POS_CENTER);

  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (dialog1), table2);

  gtk_widget_ref (button2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button2", button2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button2);
  gtk_table_attach (GTK_TABLE (table2), button2, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button2), 2);

  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_table_attach (GTK_TABLE (table2), button1, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button1), 2);

  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_table_attach (GTK_TABLE (table2), label1, 0, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  gtk_signal_connect (GTK_OBJECT (button2), "clicked",
                      GTK_SIGNAL_FUNC (on_rezultat_clicked),
		      GINT_TO_POINTER(0));
  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (on_rezultat_clicked),
		      GINT_TO_POINTER(1));
  gtk_signal_connect (GTK_OBJECT (dialog1), "destroy",
                      GTK_SIGNAL_FUNC (on_rezultat_clicked),
		      GINT_TO_POINTER(-1));
  gtk_signal_connect (GTK_OBJECT (dialog1), "delete_event",
                      GTK_SIGNAL_FUNC (on_rezultat_clicked),
		      GINT_TO_POINTER(-1));

  gtk_widget_show (dialog1);
  rezultat=-1;dialog_active=TRUE;
  while(dialog_active) g_refresh();/* wait to dialog is closed */
  gtk_widget_destroy(GTK_WIDGET (dialog1));
}/* end qdialog() */

GtkWidget *create_progress(const gchar *ptitle)
{
GtkWidget *pvbox;
GtkWidget *pwindow;

pwindow=gtk_window_new (GTK_WINDOW_TOPLEVEL);
gtk_object_set_data (GTK_OBJECT (pwindow), "pwindow", pwindow);
gtk_container_set_border_width (GTK_CONTAINER (pwindow), 2);
gtk_window_set_title (GTK_WINDOW (pwindow), ptitle);
gtk_window_set_position (GTK_WINDOW (pwindow), GTK_WIN_POS_MOUSE);
gtk_window_set_default_size (GTK_WINDOW (pwindow), 300, 50);

pvbox = gtk_vbox_new (FALSE, 0);
gtk_widget_ref (pvbox);
gtk_object_set_data_full (GTK_OBJECT (pwindow), "pvbox", pvbox,
                         (GtkDestroyNotify) gtk_widget_unref);
gtk_widget_show (pvbox);
gtk_container_add (GTK_CONTAINER (pwindow), pvbox);

plabel = gtk_label_new ("plabel");
gtk_widget_ref (plabel);
gtk_object_set_data_full (GTK_OBJECT (pwindow), "plabel", plabel,
                         (GtkDestroyNotify) gtk_widget_unref);
gtk_widget_show (plabel);
gtk_box_pack_start (GTK_BOX (pvbox), plabel, TRUE, TRUE, 0);

pprogressbar = gtk_progress_bar_new ();
gtk_widget_ref (pprogressbar);
gtk_object_set_data_full (GTK_OBJECT (pwindow), "pprogressbar", pprogressbar,
                         (GtkDestroyNotify) gtk_widget_unref);
gtk_widget_show (pprogressbar);
gtk_box_pack_start (GTK_BOX (pvbox), pprogressbar, FALSE, TRUE, 0);
gtk_progress_configure (GTK_PROGRESS (pprogressbar), 0.00, 0.00, 1.00);
gtk_progress_set_activity_mode (GTK_PROGRESS (pprogressbar), FALSE);
gtk_progress_set_show_text (GTK_PROGRESS (pprogressbar), TRUE);

return pwindow;
}/* end create_progress() */
