/******************************************************************************
    Program ictdatedit, builds and edit database from analyze test files,
    for ic-tester program:
    - ictdat.h - header file for prototype functions

    Copyright (C) 2001 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#include <gtk/gtk.h>

GtkWidget *databaseloc;/* label to show database location */
GtkWidget *savedatabase;/* save database button */
GtkWidget *typeIsize;/* labal for display infile information */
GtkWidget *islink;/* check box for link */
GtkWidget *istest;/* check box for test */
GtkWidget *delbutton;/* del button for removing entry from list */
GtkWidget *description;/* description of ic */
GtkWidget *tfncombo;/* combo select list for entries */
GtkWidget *truename;/* real name of ic (SN7400) */
GtkWidget *testediclist;/* list of tested ics */
GtkWidget *authorslist;/* list of authors */
GtkWidget *moddate;/* date of last modification */
GtkWidget *testtext;/* list of teste data */
GtkWidget *savebutton;/* save button for entry in list */
GtkWidget *newbutton;/* new button for entry in list */
GtkWidget *inportbutton;/* inport button for inporting analyze file to entry */
GtkWidget *exportbutton;/* export button for exporting entry to analyze file */
GtkWidget *lfncombo;/* combo select list for link location */
gchar fileloc[512];/* location of file from file select dilaog */
gint rezultat;/* rezults from question dialog */
gboolean dialog_active;/* check from info dialog */

/* database structures */
struct adloc {
	GList *tfnlist;/* public list for combo box */
	GList *lfnlist;/* public list for link locations */
	char databaseloc[512];/* location of database */
	gboolean changed;/* 0 -database is not changed, 1 -there are changes */
} adbi; /* All DataBase Information */

struct dat {
	gboolean islnk;/* type of data, TRUE - it's link, FALSE - test data */
	gboolean tfname;/* true test name exists as entry (for update) */
	gchar entry[256];/* temporary entry for read and write */
	gboolean changed;/* 0 - entry is not changed, 1 - there are changes */
} ictdata;/* all entry information */
