/******************************************************************************
    Program ictdatedit, builds and edit database from analyze test files,
    for ic-tester program:
    - save.c - source file for functions which saves informtions to file

    Copyright (C) 2001 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#include <stdio.h>
#include <errno.h>
#include <string.h>

#include "ictdat.h"
#include "dialog.h"
#include "refresh.h"
#include "convert.h"

gboolean SaveEntry(const gchar *flocation)
{
FILE *f;
guint chevap,i;
gulong fotsize;

if((f=fopen(g_strconcat(flocation,".info",NULL),"wb"))==NULL){/* cann't write */
 quick_message(g_strconcat("\nOho, can not open info file ",flocation,"!\n\
 Error: ",g_strerror(errno),NULL));return(TRUE);/* return error */
}else{/* all ok file open */
 ictdata.entry[0]=0;strcpy(ictdata.entry,gtk_entry_get_text(GTK_ENTRY(\
	GTK_COMBO(tfncombo)->entry)));i=strlen(ictdata.entry);
 if(ictdata.islnk) i|=128;/* mark link or test entry */
 fprintf(f,"%c%s",i,ictdata.entry);/* write name */
 if(ictdata.islnk){/* link entry write location */
  ictdata.entry[0]=0;strcpy(ictdata.entry,gtk_entry_get_text(GTK_ENTRY(\
	GTK_COMBO(lfncombo)->entry)));i=strlen(ictdata.entry);
  fprintf(f,"%c%s",i,ictdata.entry);/* write link */
 }/* end if islink */
 fclose(f);/* close file, size for temp file we will add when we created it */
 if((f=fopen(g_strconcat(flocation,".tmp",NULL),"wb"))==NULL){/* cann't write */
 quick_message(g_strconcat("\nOho, can not open temp file ",flocation,"!\n\
 Error: ",g_strerror(errno),NULL));return(TRUE);/* return error */
 }else{/* all ok file open */
  ictdata.entry[0]=0;strcpy(ictdata.entry,gtk_entry_get_text(\
	GTK_ENTRY(truename)));i=strlen(ictdata.entry);
  fprintf(f,"%c%s",i,ictdata.entry);/* write true name */
  ictdata.entry[0]=0;strcpy(ictdata.entry,gtk_entry_get_text(\
	GTK_ENTRY(description)));i=strlen(ictdata.entry);
  fprintf(f,"%c%s",i,ictdata.entry);/* write ic description */
  chevap=gtk_text_get_length(GTK_TEXT(testediclist));
  to256((gulong *)chevap,ictdata.entry,2);fprintf(f,"%c%c",ictdata.entry[0],
	ictdata.entry[1]);/* write list size of tested ics */
  for(chevap=0;chevap<(ictdata.entry[0]*256+ictdata.entry[1]);chevap++)
   fprintf(f,"%c",GTK_TEXT_INDEX(GTK_TEXT(testediclist),chevap));
  chevap=gtk_text_get_length(GTK_TEXT(authorslist));
  to256((gulong *)chevap,ictdata.entry,2);fprintf(f,"%c%c",ictdata.entry[0],
	ictdata.entry[1]);/* write list size of authors */
  for(chevap=0;chevap<(ictdata.entry[0]*256+ictdata.entry[1]);chevap++)
   fprintf(f,"%c",GTK_TEXT_INDEX(GTK_TEXT(authorslist),chevap));
  ictdata.entry[0]=0;strcpy(ictdata.entry,gtk_entry_get_text(\
	GTK_ENTRY(moddate)));ictdata.entry[20]=0;
  fprintf(f,"%20s%c%c%c%c",ictdata.entry,0,0,0,0);/* write date and skip size */
  chevap=0;
  for(fotsize=0;fotsize<gtk_text_get_length(GTK_TEXT(testtext));fotsize++){
   ictdata.entry[chevap]=GTK_TEXT_INDEX(GTK_TEXT(testtext),fotsize);
   if(ictdata.entry[chevap]=='\n'){/* end of line */
    ictdata.entry[chevap]=0;chevap=0;
    if((ictdata.entry[1]==':')&&(ictdata.entry[2]==32)){/* ok action is here */
     switch (ictdata.entry[0]){/* check action */
	case 'P':/* paused entry */
		for(i=0;i<=9;i++) ictdata.entry[i]=ictdata.entry[i+3];
		ictdata.entry[10]=0;i=strlen(ictdata.entry);/* get size */
		fprintf(f,"%c%c%s",4,i,ictdata.entry);break;/* wrote pause */
	case 'W':/* write entry */
		for(i=0;(i<=252)&&(ictdata.entry[i]!=0);i++)
			ictdata.entry[i]=ictdata.entry[i+3];/* remove action */
		doto4(ictdata.entry);/* convert to 4 bit entry */
		fprintf(f,"%c%c%c%c%c",0,ictdata.entry[0],ictdata.entry[1],
			ictdata.entry[2],ictdata.entry[3]);break;/* wrote */
	case 'R':/* read entry */
		for(i=0;(i<=252)&&(ictdata.entry[i]!=0);i++)
			ictdata.entry[i]=ictdata.entry[i+3];/* remove action */
		doto4(ictdata.entry);/* convert to 4 bit entry */
		fprintf(f,"%c%c%c%c%c",1,ictdata.entry[0],ictdata.entry[1],
			ictdata.entry[2],ictdata.entry[3]);break;/* wrote */
	case 'E':/* error entry */
		for(i=0;(i<=252)&&(ictdata.entry[i]!=0);i++)
			ictdata.entry[i]=ictdata.entry[i+3];/* remove action */
		i=strlen(ictdata.entry);/* get size */
		fprintf(f,"%c%c%s",2,i,ictdata.entry);break;/* wrote error */
	case '?':/* question error entry */
		for(i=0;(i<=252)&&(ictdata.entry[i]!=0);i++)
			ictdata.entry[i]=ictdata.entry[i+3];/* remove action */
		i=strlen(ictdata.entry);/* get size */
		fprintf(f,"%c%c%s",3,i,ictdata.entry);break;/* wrote error */
	default:/* kme? what's that? */
     		quick_message(g_strconcat("\nKme ?!\nUnknown action entry:\n\"",
			ictdata.entry,"\"\nThis information isn't saved.\n",
	"It's possible that this is part of new version, upgrade program.",
			NULL));break;/* wrote error */
     }/* end switch */
    }else/* error, not action */
     quick_message(g_strconcat("\nKme ?!\nUnknown entry:\n\"",ictdata.entry,
	"\"\nIf you wrote this incorretly, fix it and save again.\n",
"Each action must be wroted in one line, with up to 255 characters.",NULL));
   }else{ chevap++; if(chevap>255) chevap=255; }/* not end of line, continue */ 
  }/* end for testtext */
  fotsize=ftell(f);fclose(f);/* get size of file and close temp file */
 }/* end else if fopen */
 f=fopen(g_strconcat(flocation,".info",NULL),"ab");/* open at end of file */
 to256((gulong *)fotsize,ictdata.entry,4);/* convert it */
 fprintf(f,"%c%c%c%c",ictdata.entry[0],ictdata.entry[1],ictdata.entry[2],
	ictdata.entry[3]);/* write 4 bit for skip temp data file */
 fotsize+=ftell(f);fclose(f);/* close file */
 sprintf(ictdata.entry,"In database entry size: %ld Bytes",fotsize);
 gtk_label_set_text (GTK_LABEL(typeIsize), ictdata.entry);/* write size */
 return(FALSE);/* return ok */
}/* end else if fopen */
}/* end SaveEntry() */

void AddFromEntry(gpointer data, gpointer user_data)
{
FILE *f;
gint bufsize;

gtk_label_set_text(GTK_LABEL(plabel),(gchar *)data);/* set working entry */
rezultat++;gtk_progress_bar_update(GTK_PROGRESS_BAR(pprogressbar),
	(gfloat)rezultat/(gfloat)g_list_length(adbi.tfnlist));g_refresh();
if(dialog_active){/* all ok continue */
 strcpy(fileloc,g_strconcat(adbi.databaseloc,"/",(gchar *)data,".info",NULL));
 if((f=fopen(fileloc,"rb"))==NULL){/* can't read info file */
  quick_message(g_strconcat("\nKmeeee!?! Cann't read info entry:\n",fileloc,
	"\nError:",g_strerror(errno),"\n",NULL));dialog_active=FALSE;
 }else{ bufsize=0;/* all ok copy data */
  while(!feof(f)){/* go to the end of file */
   bufsize=fread(ictdata.entry,1,255,f);/* read file */
   if(bufsize!=fwrite(ictdata.entry,1,bufsize,user_data)){/* error in write */
    quick_message(g_strconcat("\nWoha!!!\nCan not write to database!\n",
	"Error:",g_strerror(errno),"\n",NULL));dialog_active=FALSE;
   }/* end if error */
  } fclose(f); /* end while */
 } g_refresh(); /* end if fopen */
 strcpy(fileloc,g_strconcat(adbi.databaseloc,"/",(gchar *)data,".tmp",NULL));
 if((f=fopen(fileloc,"rb"))==NULL){/* can't read temp file */
  quick_message(g_strconcat("\nKmeeee!?! Cann't read temp entry:\n",fileloc,
	"\nError:",g_strerror(errno),"\n",NULL));dialog_active=FALSE;
 }else{ bufsize=0;/* all ok copy data */
  while(!feof(f)){/* go to the end of file */
   bufsize=fread(ictdata.entry,1,255,f);/* read file */
   if(bufsize!=fwrite(ictdata.entry,1,bufsize,user_data)){/* error in write */
    quick_message(g_strconcat("\nWoha!!!\nCan not write to database!\n",
	"Error:",g_strerror(errno),"\n",NULL));dialog_active=FALSE;
   }/* end if error */
  } fclose(f); /* end while */
 } g_refresh(); /* end if fopen */
}/* end if dialog_active */
}/* end AddFromEntry() */

gboolean SaveDBase(const gchar *dlocation)
{
FILE *f;
GtkWidget *progr;

if((f=fopen(g_strconcat(dlocation,"t",NULL),"w"))==NULL){/* not opened */
 quick_message(g_strconcat("\nEk!?! Cann't write to new database:\n",dlocation,
	"t\nError:",g_strerror(errno),"\n",NULL));return(FALSE);
}else{/* all ok create database */
 progr=create_progress("Saving database...");dialog_active=TRUE;
 gtk_widget_show(progr);rezultat=0;/* create window, and do init */
 fprintf(f,"%c%c%c",255,0,1);g_refresh();/* write type (255+0) & version (1) */
 g_list_foreach(adbi.tfnlist,(GFunc)AddFromEntry,f);/* add file */
 fclose(f);gtk_widget_destroy(progr);
 if(!dialog_active) quick_message("\nSaving, aborted!\n");
 return(dialog_active);/* all ok */
}/* end else if fopen */
}/* end SaveDBase() */
